%bcond_with reconf

%undefine _disable_source_fetch

Name: R
Version: 3.5.1
Release: 8
License: GPL-2.0-only
Summary: R Programming Language
Url: https://www.r-project.org

Source0: https://mirror.las.iastate.edu/CRAN/src/base/R-3/R-%{version}.tar.gz

Patch0: R-fix-sed-for-libR-pkgconfig.patch
Patch1: R-dynload-svr4-style-shared-libraries.patch

BuildRequires: blas-devel
BuildRequires: bzip2-devel
BuildRequires: curl-devel
BuildRequires: lapack-devel
BuildRequires: libffi-devel
BuildRequires: libiconv-devel
BuildRequires: libintl-devel
BuildRequires: libjpeg-turbo-devel
BuildRequires: libpng-devel
BuildRequires: libutil-devel
# Note: Seems pcre is *required* in R 3, even when building with pcre2
# We can build with pcre2 only when we upgrade to R 4
BuildRequires: pcre-devel
BuildRequires: pcre2-devel
BuildRequires: readline-devel
BuildRequires: tcl-devel
BuildRequires: tk-devel
BuildRequires: xz-devel
BuildRequires: zlib-devel

BuildRequires: gcc-gfortran
BuildRequires: bison
BuildRequires: coreutils-gnu
BuildRequires: pkg-config

# TODO: Why is this required by R?
Requires: coreutils-gnu

%description
R is a programming language and free software environment for statistical
computing and graphics supported by the R Foundation for Statistical Computing.

The R language is widely used among statisticians and data miners for
developing statistical software and data analysis.

%package devel
Requires: %{name} = %{version}-%{release}
Group: Development/Libraries
Summary: Files needed for building R extensions

%description devel
The R-devel package contains the files needed for building R extensions.

%prep
%setup -q

%patch0 -p1
%patch1 -p1

%build

%if ! %{with reconf}
%define _host powerpc-ibm-aix6
%endif

%configure \
    ac_cv_have_decl_utimensat=no \
    CFLAGS="-I%{_includedir} -I%{_includedir}/libiconv -ftls-model=global-dynamic" \
    CPPFLAGS="-I%{_includedir} -I%{_includedir}/libiconv" \
    CXXPICFLAGS="-I%{_includedir} -I%{_includedir}/libiconv -ftls-model=global-dynamic -fPIC -fpic -DPIC" \
    LDFLAGS="-pthread -liconv -Wl,-brtl,-liconv,-bbigtoc,-bnoexpall,-blibpath:%{_libdir}:%{_libdir}/R/lib:/QOpenSys/usr/lib" \
    SHLIB_CXX14LDFLAGS="-shared -Wl,-brtl -Wl,-bnoquiet -lc -lm" \
    SHLIB_CXX17LDFLAGS="-shared -Wl,-brtl -Wl,-bnoquiet -lc -lm" \
    SHLIB_CXXLDFLAGS="-shared -Wl,-brtl -Wl,-bnoquiet -lc -lm" \
    SHLIB_FCLDFLAGS="-shared -Wl,-brtl -Wl,-bnoquiet -lc -lm" \
    SHLIB_LDFLAGS="-shared -Wl,-brtl,-bnoquiet,-bnoexpall -lc -lm" \
    DYLIB_LDFLAGS="-shared -Wl,-brtl,-bnoquiet,-bnoexpall -lc -lm" \
    --enable-R-shlib \
    --enable-static=no \
    --disable-static \
    --enable-shared=yes \
    --with-readline \
    --with-blas \
    --with-lapack \
    --with-libpng \
    --with-tcltk \
    --with-X11 \
    --with-jpeglib \
    --with-recommended-packages \
    --with-internal-tzcode
    
echo cleaning now 
make clean
echo building now
%make_build

touch doc/NEWS.pdf

%install

%make_install

rm %{buildroot}%{_libdir}/charset.alias || :

%files
%defattr(-, qsys, *none)
%{_bindir}/*
%{_libdir}/R
%{_mandir}/man1/*

%exclude %{_libdir}/R/include
%exclude %{_libdir}/R/SVN-REVISION

%files devel
%defattr(-, qsys, *none)
%{_libdir}/R/include/*
%{_libdir}/pkgconfig/*.pc



%changelog
* Fri Nov 20 2020 Abdirahim Musse <abdirahim.musse@ibm.com> - 3.5.1
- Allow dyn.load to work with svr4-style shared libraries

* Wed Nov 11 2020 Naveen Ram <naveen.ram@ibm.com> - 3.5.1
- Build R with PCRE2 instead of PCRE

* Thu Sep 17 2020 Naveen Ram <naveen.ram@ibm.com> - 3.5.1
- Add blas-devel to BuildRequires to link libblas

* Mon Jan 27 2020 Kevin Adler <kadler@us.ibm.com> - 3.5.1
- Fix sed delimiters used for generating libR.pc

* Tue Dec 10 2019 Abdirahim Musse <abdirahim.musse@ibm.com>
- Prevent linking to utimensat

* Fri Jul 05 2019 Jesse Gorzinski <jgorzins@us.ibm.com> 3.5.1
- Add TCL/TK support

* Mon Jun 3 2019 - Jesse R. Gorzinski <jgorzins@us.ibm.com>
- R initial spec file
